module DEIS
  class Base
    include Thor::Shell
    attr_accessor :verbose, :environment, :proxy, :cluster, :path, :output, :ssh
    YES = "\u2713"
    NO = "\u274C"


    def log(cmd)
      say "[#{@proxy} #{Time.now}] #{cmd}", :black if @verbose
    end

    # run commands either locally or remotely
    def run(command)
      self.log(command)
      if @proxy
        return @ssh.exec!(command)
      else
        return `#{command}`.strip
      end
    end

    def local_shell
      `echo $SHELL | sed -E "s#/bin/##"`.strip
    end

    def local_profile
      file = "#{ENV['HOME']}/.profile"
      `> #{file}` if ! File.exists?(file)
      file
    end

    def remote_profile
      "$HOME/.profile"
    end

    def local_shell_env_include(profile, file_to_include)
      content = File.open(profile, "r"){ |f| f.read }.gsub(". #{file_to_include}", "") + "\n. #{file_to_include}"
      File.open(profile, "w") { |f| f.write(content) }
    end

  end
end