module DEIS
  class Git

    def self.is_git?
      res = `#{DEIS::Git.is_git_cmd}`.to_i
      if res == 0 then true else false end
    end

    def self.is_git_cmd
      "git status 2>&1 | grep 'fatal: Not a git' | wc -l"
    end

    def self.name
      remote = DEIS::Git.remote
      if remote.nil? || remote.length == 0
        return "na"
      else
        `echo #{remote} | grep "/.*\.git" -o | sed -E "s#/##" | sed -E "s#.git##" 2>/dev/null`.strip
      end
    end

    def self.remote
      `c=$(git remote show | wc -l ) ; if [ "$c" -gt 0 ]; then git remote show -n origin | grep " Fetch URL:" | grep ": .*" -o | sed -E "s#: ##" 2>/dev/null ; fi`.strip
    end

    def self.ref
      `#{DEIS::Git.ref_cmd}`.strip
    end

    def self.ref_cmd
      "git rev-parse --verify HEAD 2>/dev/null"
    end

    def self.branch
      `#{DEIS::Git.branch_cmd}`.strip
    end

    def self.branch_cmd
      "git rev-parse --abbrev-ref HEAD"
    end

    def self.init_with_remote_cmd(remote)
      "git init && git remote add origin #{remote} 2>&1 | grep 'fatal:' -o | wc -l"
    end
6
    def self.checkout_to_ref_cmd(ref, branch)
      "git fetch origin && git checkout -f origin/#{branch} && git branch -d #{branch} ; git checkout -f #{branch} && git checkout -f #{ref} 2>&1 | grep 'error:' | wc -l"
    end

    # find env based token
    def self.github_token
      v = self.github_token_varname
      ENV[v]
    end

    # more advanced version that reads config files
    def self.github_token_cmd
      "cat #{DEIS::Storage::BASE_PATH}.profile  | grep #{DEIS::Git.github_token_varname}=.* -o | sed -E 's##{DEIS::Git.github_token_varname}=##' | sed -E 's#\"##g'"
    end

    def self.github_token_varname
      "GITHUB_TOKEN"
    end

  end
end